#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "apptout.h"

FILE *fp;				/* Data file pointer */
FILE *fpout;
FILE *fpin; 
long   lFirst;			/* Fisrt of data file point without DBHeader */
long   lLast;			/* Last of data file point */
long   lFileLast;		/* Last of file point */
short  iDebugG;			/* Class1 debug level */
short  iDebugG2;		/* Class2 debug level */
short  iCSV;			/* Camma flag */
short  iTAB;			/* TAB flag */
short  iETC;			/* Other info. flag */
short  iHeader;			/* Header flag */
short  iFileType;		/* File type flag */
short  iEvent;			/* Event flag */
short  iAppt;			/* Appointment flag */
short  iToDo;			/* ToDo flag */
short  iNote;			/* Note devide flag */
short  iOutAppt;		/* Output flag */
short  iInCSV;			/* Input CSV flag */
short  iDataNum;		/* All data number */
short  iNoteNum;		/* Allnote number */
short  iAllRecNum;		/* Allrecord number */
short  iAlarm;			/* Alarm flag */
short  iSilent;
short  iFileDefNum;
short  iNotePoint;
short  iOffsetLength;
short  iMerge;
long   lCutStart;
long   lCutEnd;
long   lLookUpSeek;		/* Look up seek number */
char * szUserType14_0;
short  iUserType14;
long   lLineCounter;

void main(int argc, char **argv)
{
  char	szBuffer[80];
  short	i, iCounter;
  DBHDR	dh;
  RHDR	rh;
  SCSV  start_scsv;
  PCSVD	start_csvd, other_csvd;
  PFDC	start_fdc, work_fdc;
  PFDEF	curr_fd;
  PSINF	work_sinf;
  PSINF	pSeekInfo[32];

  fprintf(stderr, "APPTOUT for DOS/UNIX Version 0.86b  "
                  "Copyright (C) 1994-2000 by nuisance\n"
                  "                                    "
                  "-1995- Special thanks obuk.\n\n");

  /* Initialize */
  iDebugG = 0;
  iDebugG2 = 0;
  iCSV = 2;
  iTAB = 0;
  iETC = 0;
  iHeader = 0;
  iFileType = 2;
  iEvent = 0;
  iAppt = 1;
  iToDo = 0;
  iNote = 2;
  iOutAppt = 0;
  iInCSV = 0;
  iDataNum = 0;
  iNoteNum = 0;
  iAllRecNum = 0;
  lLookUpSeek = 0;
  iSilent = 0;
  iMerge = 0;
  iAlarm = 7;
  iOffsetLength = 0;
  lCutStart = 19000101;
  lCutEnd = 22000101;
  iUserType14 = 0;
  iFileDefNum = 0;
  iNotePoint = -1;
  lLineCounter = 0;
  szUserType14_0 = NULL;
  for(i=0;i<32;i++)
    pSeekInfo[i] = (PSINF)NULL;
  start_fdc = (PFDC)NULL;			/* field start pointer */
  start_scsv.start_csvd = (PCSVD)NULL;
  start_scsv.other_csvd = (PCSVD)NULL;
  
  /* Not option */
  if (argc < 2) {
    usage();
    exit(0);
  }

  /* Check of option */
  if (!ReadOption(argc, argv)) exit(1);

  /* Check of 'hDC' */
  if (fread(szBuffer, 1, 4, fp) != 4){
    fprintf(stderr, "Failed read file.\n");
    exit(1);
  }
  if (strcmp(szBuffer, "hcD")){
    fprintf(stderr, "Not a valid database.\n");
    exit(1);
  }

  /* Read of Database header */  
  if (fread_DBHDR(&dh, 1, DBHDR_SIZE, fp) != DBHDR_SIZE){
    fprintf(stderr, "Failed read file.\n");
    exit(1);
  }

  iAllRecNum = dh.iNumRecords;

  /* Set file type */
  switch(dh.cFileType){
  case 'N':		/* NoteTaker */
  case 'D':		/* Database */
	iFileType = 1;
	break;
  case '2':		/* Appointment Book */
	iFileType = 2;
	break;
  default:
    fprintf(stderr, "Not support this file type.^^;\n");
    fprintf(stderr, "Please, Check your enter file name.\n");
    exit(1);
    break;
  }

  /* Write "hDC" */
  if (iOutAppt){
    fwrite(szBuffer, 4, 1, fpout);
  }

  if (iDebugG){
    fprintf(stdout, "%s\n", szBuffer);
  }

  if (iOutAppt){
    /* Add seek infomation */
    rh.cType = dh.cType;
    rh.cStatus = dh.cStatus;
    rh.iLength = dh.iLength;
    rh.iRecord = dh.iRecord;
    AddSeekInfo(pSeekInfo, &rh, ftell(fpout));

    /* Write Database header */
    fwrite_DBHDR(&dh, DBHDR_SIZE, 1, fpout);
  }

  if (iDebugG){
    CheckRecordType(dh.cType);
    CheckRecordStatus(dh.cStatus);
    fprintf(stdout, "  Record Length : %d\n", dh.iLength);
    fprintf(stdout, "  Record Number : %d\n", dh.iRecord);
    fprintf(stdout, " Release Number : %x\n", dh.iReleaseNum);
    fprintf(stdout, "  Number Record : %d\n", dh.iNumRecords);
    fprintf(stdout, "Current View Pt : %d\n", dh.iCurrViewPt);
    fprintf(stdout, "   Look Up Seek : %ld\n", dh.iLookUpSeek);
    fprintf(stdout, "      File Type : %c\n", dh.cFileType);
    CheckRecordStatus(dh.cFileStatus);
	fprintf(stdout, "   View Pt Hash : %d\n", dh.iViewPtHash1);
	fprintf(stdout, "   View Pt Hash : %d\n", dh.iViewPtHash2);
    fprintf(stdout, "Last Time Stamp : %d/%02d/%02d/:%02d:%02d\n\n",
      dh.cYear + 1900,
      dh.cMonth + 1,
      dh.cDay + 1,
      dh.iMinute/60,
      dh.iMinute%60);
  }

  /* Set Look Up Seek */
  lLookUpSeek = dh.iLookUpSeek;

  /* Save file at point without DBheader */
  lFirst = ftell(fp);

  /* Save file at last point */
  lFileLast = dh.iLookUpSeek;

  /* Read of field define */  
  start_fdc = ReadField(start_fdc, pSeekInfo);
  fseek(fp, lFirst, SEEK_SET);

  /* Read of user data */  
  ReadData(start_fdc, &start_scsv, pSeekInfo);

  /* Read of CSV data */  
  if (iInCSV){
	ReadCSV(start_fdc, &start_scsv, pSeekInfo);
  }

  /* Print header infomation */
  if (iFileType == 2)
    PrintHeader(start_fdc);

  /* Output standard out */
  if (iSilent%2 != 1){
	OutputData(&start_scsv);
  }

  /* Write data for *.adb */
  if (iOutAppt){

	/* Write TYPE_USER(14) for appointment */
	if (iFileType == 2)
	  WriteUserType14(&start_scsv, pSeekInfo);

	/* Write ViewPtTable and LookUpSeek infomation */
    iCounter = WriteLookUpSeek(pSeekInfo);

	/* Write DataBaseHeader */
    dh.cStatus = 2;
    dh.iLookUpSeek = lLast;
	dh.iNumRecords = iCounter;
	dh.cFileStatus |= 0x02;
/*	dh.iViewPtHash1 = 55;
	dh.iViewPtHash2 = 132;*/
    fseek(fpout, 4L, SEEK_SET);
    fwrite_DBHDR(&dh, DBHDR_SIZE, 1, fpout);
  }

  /* Print FIELDDEF for debug */
  if(iDebugG){
    for(work_fdc = start_fdc; work_fdc; work_fdc = work_fdc->pnext_fdc){
      curr_fd = work_fdc->pfd;
      fprintf(stdout,  "     Field Type : %d\n", curr_fd->cFieldType);
      fprintf(stdout,  "       Field ID : %d\n", curr_fd->cFieldID);
      fprintf(stdout,  "    Data Offset : %d\n", curr_fd->iDataOffset);
      fprintf(stdout,  "          Flags : 0x%x\n", curr_fd->cFlags);
      fprintf(stdout,  "       Reserved : %d\n", 
      			curr_fd->cReserved2*256 + curr_fd->cReserved1);
      fprintf(stdout,  "           Data : %s\n\n", work_fdc->szName);
    }
    fprintf(stdout,    "All data Number : %d\n\n", iDataNum);

    iCounter = 0;
    for(i=0;i<32;i++){
      for(work_sinf=pSeekInfo[i];work_sinf;work_sinf=work_sinf->pnext_sinf)
        iCounter++;
    }
    fprintf(stdout, "iCounter = %d\n", iCounter);
    fprintf(stdout, "iNoteNum = %d\n", iNoteNum);
  }

  fclose(fp);
  if (iInCSV && iFileType == 2){
	fclose(fpin);
  }
  if (iOutAppt){
	fflush(fpout);
	fclose(fpout);
  }
/*
  fprintf(stdout, "iFileDefNum=%d\n", iFileDefNum);
*/
  exit(0);
}


void usage()
{
/* fprintf(stdout, "\n"); */
fprintf(stdout, 
" Usage: apptout -x(filename) [-option[number]] [-i(filname)] [-o(filename)]\n\n");
fprintf(stdout, " Option:\n");
fprintf(stdout, "   -c0   ꥿ڤǽ\n");
fprintf(stdout, "   -c1   ޶ڤǽ\n");
fprintf(stdout, "   -c2   ޶ڤ\"\"ǽ(ǥե)\n");
fprintf(stdout, "   -b    ֶڤ\"\"ǽ\n");
fprintf(stdout, "   -a[n] ݥȥȤξ(ǥե)\n");
fprintf(stdout, "   -e[n] ٥Ȥξ\n");
fprintf(stdout, "   -t[n] ToDoξ\n");
fprintf(stdout, "      0: ̵\n");
fprintf(stdout, "      1: Non-Repeat & Repeating ξ\n");
fprintf(stdout, "      2: Non-Repeat ξ\n");
fprintf(stdout, "      3: Repeating ξ\n");
fprintf(stdout, "   -t4   ToDoνϤAppt/Event ηˤ碌ƽ\n");
fprintf(stdout, "   -h    إå\n");
fprintf(stdout, "   -s0   ǡɸϤؤνϤ޻\n");
fprintf(stdout, "   -s1   ץνϤ޻\n");
fprintf(stdout, "   -s2   ƤνϤ޻\n");
fprintf(stdout, "   -m    Ͽ\n");
fprintf(stdout, "   -n0   NOTEξֲԥɡפΤޤޤǽ\n");
fprintf(stdout, "   -n1   NOTEξֲԥɡפ򥹥ڡѴƽ\n");
fprintf(stdout, "   -n2   NOTEξֲԥɡפ\"\\n\"ʸѴƽ(ǥե)\n\n");
fprintf(stdout, "   -r[n] 顼ࡿɽɽ\n");
fprintf(stdout, "      0:Alarm=OFF           MonthView=OFFWeekView=OFF\n");
fprintf(stdout, "      1:Alarm=ON(LeadTime=5)MonthView=OFFWeekView=OFF\n");
fprintf(stdout, "      2:Alarm=OFF           MonthView=ON WeekView=OFF\n");
fprintf(stdout, "      3:Alarm=ON(LeadTime=5)MonthView=ON WeekView=OFF\n");
fprintf(stdout, "      4:Alarm=OFF           MonthView=OFFWeekView=ON\n");
fprintf(stdout, "      5:Alarm=ON(LeadTime=5)MonthView=OFFWeekView=ON\n");
fprintf(stdout, "      6:Alarm=OFF           MonthView=ON WeekView=ON\n");
fprintf(stdout, "      7:Alarm=ON(LeadTime=5)MonthView=ON WeekView=ON(ǥե)\n\n");
fprintf(stdout, "   -g[YYMMDD]   Ϥγex.) 940404\n");
fprintf(stdout, "   -f[YYMMDD]   Ϥνλex.) 941231\n");
fprintf(stdout, "   -x(filename)   ϥե̾(ɬ)\n");
fprintf(stdout, "   -i(filename)   CSVϥե̾\n");
fprintf(stdout, "   -o(filename)   ϥե̾\n\n");
fprintf(stdout, "   -?   إ  ץν֤Ǥ\n");
}
