#include <stdlib.h>

#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif

#define TYPE_DBHEADER     0
#define TYPE_CARDDEF      4
#define TYPE_CATEGORY     5
#define TYPE_FIELDDEF     6
#define TYPE_VIEWPTDEF    7
#define TYPE_NOTE         9
#define TYPE_VIEWPTTABLE 10
#define TYPE_DATA        11
#define TYPE_LINKDEF     12
#define TYPE_CARDPAGEDEF 13
#define TYPE_LOOKUPTABLE 31

#define RHDR_SIZE         6
#define DBHDR_SIZE       25
#define NRA_SIZE         27
#define FDEF_SIZE         7
#define RIA_SIZE         12

#define BUF            10241

typedef struct RecordHeader{
  unsigned char cType;
  unsigned char cStatus;
  short iLength;
  short iRecord;
}RHDR, *PRHDR;

typedef struct DBHeader{
  unsigned char cType;
  unsigned char cStatus;
  short iLength;
  short iRecord;
  short iReleaseNum;
  unsigned char cFileType;
  unsigned char cFileStatus;
  short iCurrViewPt;
  short iNumRecords;
  long iLookUpSeek;
  unsigned char cYear;
  unsigned char cMonth;
  unsigned char cDay;
  short iMinute;
  unsigned char iViewPtHash1;
  unsigned char iViewPtHash2;
}DBHDR, *PDBHDR;

typedef struct FieldDefine{
  unsigned char cFieldType;
  unsigned char cFieldID;
  short iDataOffset;
  unsigned char cFlags;
  unsigned char cReserved1;
  unsigned char cReserved2;
}FDEF, *PFDEF;

typedef struct FieldDefineChain{
  unsigned char * szName;
  PFDEF pfd;
  struct FieldDefineChain * pnext_fdc;
}FDC, *PFDC;

typedef struct NonRepeaAppt{
  short iLength;
  short iOsCategory;
  short iOsLocation;
  short iOsRepeat;
  short iNoteRecNum;
  short iPrevRecNum;
  short iNextRecNum;
  unsigned char cFlags;
  unsigned char cYear;
  unsigned char cMonth;
  unsigned char cDay;
  unsigned char cStartTimePri1;
  unsigned char cStartTimePri2;
  unsigned short iEndDate;
  unsigned char cEndTimeYear;
  unsigned char cEndTimeMonth;
  unsigned char cLeadTimeDay;
  unsigned char cLeadTime;
  char cRepeatType;		/* 1:none 2:days 4:weeks 8:months 16:years 32:custom */
}NRA, *PNRA;

typedef struct RepeatInformationAppt{
  char cFreq;
  unsigned char Days;
  unsigned char Weeks;
  unsigned char Month1;
  unsigned char Month2;
  unsigned char cStartYear;
  unsigned char cStartMonth;
  unsigned char cStartDay;
  unsigned char cEndYear;
  unsigned char cEndMonth;
  unsigned char cEndDay;
  char cDelete;
}RIA, *PRIA;

typedef struct CSVData{
  char * pszDescription;
  char * pszCategory;
  char * pszLocation;
  char * pszNote;
  char * pszDelRepeat;
  short iRecordNum;
  short iFirstRecord;
  short iStartTimeFlag;
  short iEndTimeFlag;
  unsigned char cKind;
  PNRA pnra;
  PRIA pria;
  struct CSVData * pdown_csvd;
  struct CSVData * pnext_csvd;
}CSVD, *PCSVD;

typedef struct SeekInfomation{
  long lSeekPt;
  short iSize;
  short iRecordNum;
  struct SeekInfomation * pnext_sinf;
}SINF, *PSINF;

typedef struct StartCSV{
  PCSVD start_csvd;
  PCSVD other_csvd;
}SCSV, *PSCSV;

short  CheckRecordType(char);
void   CheckRecordStatus(char);
PFDC   ReadField(PFDC, PSINF*);
void   ReadData(PFDC, PSCSV, PSINF*);
char * ReadNote(short, char);
void   PrintString(char*, char*, short);
char * ReadAppt(PFDC, PCSVD, unsigned char*, short);
char * ReadTodo(PFDC, PCSVD, unsigned char*, short);
void   ReadDB(PFDC, PSINF*, unsigned char*, char*);
void   ReadCSV(PFDC, PSCSV, PSINF*);
char * ReadRepeatDay(short);
short  GetRepeatDay(char*);
short  GetRepeatMonth(char*);
char * ReadRepeatMonth(short);

char * GetCSV(char*, short, char);
char * GetString(char*);
void   WriteDATA(PCSVD, PSINF*);
void   WriteDB(PFDC, PSINF*, char*);

int    ReadOption(int, char**);
void   PrintHeader(PFDC);
void   AddSeekInfo(PSINF*, PRHDR, long);
void   AddUserType14(PSCSV, PCSVD, PSINF*);
int    WriteLookUpSeek(PSINF*);
void   WriteUserType14(PSCSV, PSINF*);
char * ChangeString(char*);
char * CutString(char*, int, int);

void   CSVToNRAAppt(PCSVD, unsigned char*, short);
void   CSVToNRAToDo(PCSVD, unsigned char*, short);
PCSVD  AddChainForDay(PCSVD, PCSVD, short);
PCSVD  AddChainForTime(PCSVD, PCSVD);

void   WriteCSV(PCSVD);
void   OutputData(PSCSV);

void   usage(void);
PCSVD  MakeCSVD(char);
