#include <stdio.h>
#include "apptout.h"

static void fwerr(char *s, int r, int e)
{
 fprintf(stderr, "fwrite_%s: %d bytes written (%d bytes expected)\n", s, r, e);
 exit(1);
}

static void frerr(char *s, int r, int e)
{
 fprintf(stderr, "fread_%s: %d bytes read (%d bytes expected)\n", s, r, e);
 exit(1);
}

int fwrite_RHDR(RHDR *p, int n, int m, FILE *f)
{
 int i = 0;
 if (fwrite(&p->cType, sizeof(p->cType), 1, f) != 1) return -1;
 i += sizeof(p->cType);
 if (fwrite(&p->cStatus, sizeof(p->cStatus), 1, f) != 1) return -1;
 i += sizeof(p->cStatus);
 if (fwrite(&p->iLength, sizeof(p->iLength), 1, f) != 1) return -1;
 i += sizeof(p->iLength);
 if (fwrite(&p->iRecord, sizeof(p->iRecord), 1, f) != 1) return -1;
 i += sizeof(p->iRecord);
 if (i != n*m) fwerr("RHDR", i, n*m);
 return m;
}

int fread_RHDR(RHDR *p, int n, int m, FILE *f)
{
 int i = 0;
 if (fread(&p->cType, sizeof(p->cType), 1, f) != 1) return -1;
 i += sizeof(p->cType);
 if (fread(&p->cStatus, sizeof(p->cStatus), 1, f) != 1) return -1;
 i += sizeof(p->cStatus);
 if (fread(&p->iLength, sizeof(p->iLength), 1, f) != 1) return -1;
 i += sizeof(p->iLength);
 if (fread(&p->iRecord, sizeof(p->iRecord), 1, f) != 1) return -1;
 i += sizeof(p->iRecord);
 if (i != n*m) frerr("RHDR", i, n*m);
 return m;
}

int fwrite_DBHDR(DBHDR *p, int n, int m, FILE *f)
{
 int i = 0;
 if (fwrite(&p->cType, sizeof(p->cType), 1, f) != 1) return -1;
 i += sizeof(p->cType);
 if (fwrite(&p->cStatus, sizeof(p->cStatus), 1, f) != 1) return -1;
 i += sizeof(p->cStatus);
 if (fwrite(&p->iLength, sizeof(p->iLength), 1, f) != 1) return -1;
 i += sizeof(p->iLength);
 if (fwrite(&p->iRecord, sizeof(p->iRecord), 1, f) != 1) return -1;
 i += sizeof(p->iRecord);
 if (fwrite(&p->iReleaseNum, sizeof(p->iReleaseNum), 1, f) != 1) return -1;
 i += sizeof(p->iReleaseNum);
 if (fwrite(&p->cFileType, sizeof(p->cFileType), 1, f) != 1) return -1;
 i += sizeof(p->cFileType);
 if (fwrite(&p->cFileStatus, sizeof(p->cFileStatus), 1, f) != 1) return -1;
 i += sizeof(p->cFileStatus);
 if (fwrite(&p->iCurrViewPt, sizeof(p->iCurrViewPt), 1, f) != 1) return -1;
 i += sizeof(p->iCurrViewPt);
 if (fwrite(&p->iNumRecords, sizeof(p->iNumRecords), 1, f) != 1) return -1;
 i += sizeof(p->iNumRecords);
 if (fwrite(&p->iLookUpSeek, sizeof(p->iLookUpSeek), 1, f) != 1) return -1;
 i += sizeof(p->iLookUpSeek);
 if (fwrite(&p->cYear, sizeof(p->cYear), 1, f) != 1) return -1;
 i += sizeof(p->cYear);
 if (fwrite(&p->cMonth, sizeof(p->cMonth), 1, f) != 1) return -1;
 i += sizeof(p->cMonth);
 if (fwrite(&p->cDay, sizeof(p->cDay), 1, f) != 1) return -1;
 i += sizeof(p->cDay);
 if (fwrite(&p->iMinute, sizeof(p->iMinute), 1, f) != 1) return -1;
 i += sizeof(p->iMinute);
 if (fwrite(&p->iViewPtHash1, sizeof(p->iViewPtHash1), 1, f) != 1) return -1;
 i += sizeof(p->iViewPtHash1);
 if (fwrite(&p->iViewPtHash2, sizeof(p->iViewPtHash2), 1, f) != 1) return -1;
 i += sizeof(p->iViewPtHash2);
 if (i != n*m) fwerr("DBHDR", i, n*m);
 return m;
}

int fread_DBHDR(DBHDR *p, int n, int m, FILE *f)
{
 int i = 0;
 if (fread(&p->cType, sizeof(p->cType), 1, f) != 1) return -1;
 i += sizeof(p->cType);
 if (fread(&p->cStatus, sizeof(p->cStatus), 1, f) != 1) return -1;
 i += sizeof(p->cStatus);
 if (fread(&p->iLength, sizeof(p->iLength), 1, f) != 1) return -1;
 i += sizeof(p->iLength);
 if (fread(&p->iRecord, sizeof(p->iRecord), 1, f) != 1) return -1;
 i += sizeof(p->iRecord);
 if (fread(&p->iReleaseNum, sizeof(p->iReleaseNum), 1, f) != 1) return -1;
 i += sizeof(p->iReleaseNum);
 if (fread(&p->cFileType, sizeof(p->cFileType), 1, f) != 1) return -1;
 i += sizeof(p->cFileType);
 if (fread(&p->cFileStatus, sizeof(p->cFileStatus), 1, f) != 1) return -1;
 i += sizeof(p->cFileStatus);
 if (fread(&p->iCurrViewPt, sizeof(p->iCurrViewPt), 1, f) != 1) return -1;
 i += sizeof(p->iCurrViewPt);
 if (fread(&p->iNumRecords, sizeof(p->iNumRecords), 1, f) != 1) return -1;
 i += sizeof(p->iNumRecords);
 if (fread(&p->iLookUpSeek, sizeof(p->iLookUpSeek), 1, f) != 1) return -1;
 i += sizeof(p->iLookUpSeek);
 if (fread(&p->cYear, sizeof(p->cYear), 1, f) != 1) return -1;
 i += sizeof(p->cYear);
 if (fread(&p->cMonth, sizeof(p->cMonth), 1, f) != 1) return -1;
 i += sizeof(p->cMonth);
 if (fread(&p->cDay, sizeof(p->cDay), 1, f) != 1) return -1;
 i += sizeof(p->cDay);
 if (fread(&p->iMinute, sizeof(p->iMinute), 1, f) != 1) return -1;
 i += sizeof(p->iMinute);
 if (fread(&p->iViewPtHash1, sizeof(p->iViewPtHash1), 1, f) != 1) return -1;
 i += sizeof(p->iViewPtHash1);
 if (fread(&p->iViewPtHash2, sizeof(p->iViewPtHash2), 1, f) != 1) return -1;
 i += sizeof(p->iViewPtHash2);
 if (i != n*m) frerr("DBHDR", i, n*m);
 return m;
}

int fwrite_FDEF(FDEF *p, int n, int m, FILE *f)
{
 int i = 0;
 if (fwrite(&p->cFieldType, sizeof(p->cFieldType), 1, f) != 1) return -1;
 i += sizeof(p->cFieldType);
 if (fwrite(&p->cFieldID, sizeof(p->cFieldID), 1, f) != 1) return -1;
 i += sizeof(p->cFieldID);
 if (fwrite(&p->iDataOffset, sizeof(p->iDataOffset), 1, f) != 1) return -1;
 i += sizeof(p->iDataOffset);
 if (fwrite(&p->cFlags, sizeof(p->cFlags), 1, f) != 1) return -1;
 i += sizeof(p->cFlags);
 if (fwrite(&p->cReserved1, sizeof(p->cReserved1), 1, f) != 1) return -1;
 i += sizeof(p->cReserved1);
 if (fwrite(&p->cReserved2, sizeof(p->cReserved2), 1, f) != 1) return -1;
 i += sizeof(p->cReserved2);
 if (i != n*m) fwerr("FDEF", i, n*m);
 return m;
}

int fread_FDEF(FDEF *p, int n, int m, FILE *f)
{
 int i = 0;
 if (fread(&p->cFieldType, sizeof(p->cFieldType), 1, f) != 1) return -1;
 i += sizeof(p->cFieldType);
 if (fread(&p->cFieldID, sizeof(p->cFieldID), 1, f) != 1) return -1;
 i += sizeof(p->cFieldID);
 if (fread(&p->iDataOffset, sizeof(p->iDataOffset), 1, f) != 1) return -1;
 i += sizeof(p->iDataOffset);
 if (fread(&p->cFlags, sizeof(p->cFlags), 1, f) != 1) return -1;
 i += sizeof(p->cFlags);
 if (fread(&p->cReserved1, sizeof(p->cReserved1), 1, f) != 1) return -1;
 i += sizeof(p->cReserved1);
 if (fread(&p->cReserved2, sizeof(p->cReserved2), 1, f) != 1) return -1;
 i += sizeof(p->cReserved2);
 if (i != n*m) frerr("FDEF", i, n*m);
 return m;
}

int fwrite_NRA(NRA *p, int n, int m, FILE *f)
{
 int i = 0;
 if (fwrite(&p->iLength, sizeof(p->iLength), 1, f) != 1) return -1;
 i += sizeof(p->iLength);
 if (fwrite(&p->iOsCategory, sizeof(p->iOsCategory), 1, f) != 1) return -1;
 i += sizeof(p->iOsCategory);
 if (fwrite(&p->iOsLocation, sizeof(p->iOsLocation), 1, f) != 1) return -1;
 i += sizeof(p->iOsLocation);
 if (fwrite(&p->iOsRepeat, sizeof(p->iOsRepeat), 1, f) != 1) return -1;
 i += sizeof(p->iOsRepeat);
 if (fwrite(&p->iNoteRecNum, sizeof(p->iNoteRecNum), 1, f) != 1) return -1;
 i += sizeof(p->iNoteRecNum);
 if (fwrite(&p->iPrevRecNum, sizeof(p->iPrevRecNum), 1, f) != 1) return -1;
 i += sizeof(p->iPrevRecNum);
 if (fwrite(&p->iNextRecNum, sizeof(p->iNextRecNum), 1, f) != 1) return -1;
 i += sizeof(p->iNextRecNum);
 if (fwrite(&p->cFlags, sizeof(p->cFlags), 1, f) != 1) return -1;
 i += sizeof(p->cFlags);
 if (fwrite(&p->cYear, sizeof(p->cYear), 1, f) != 1) return -1;
 i += sizeof(p->cYear);
 if (fwrite(&p->cMonth, sizeof(p->cMonth), 1, f) != 1) return -1;
 i += sizeof(p->cMonth);
 if (fwrite(&p->cDay, sizeof(p->cDay), 1, f) != 1) return -1;
 i += sizeof(p->cDay);
 if (fwrite(&p->cStartTimePri1, sizeof(p->cStartTimePri1), 1, f) != 1) return -1;
 i += sizeof(p->cStartTimePri1);
 if (fwrite(&p->cStartTimePri2, sizeof(p->cStartTimePri2), 1, f) != 1) return -1;
 i += sizeof(p->cStartTimePri2);
 if (fwrite(&p->iEndDate, sizeof(p->iEndDate), 1, f) != 1) return -1;
 i += sizeof(p->iEndDate);
 if (fwrite(&p->cEndTimeYear, sizeof(p->cEndTimeYear), 1, f) != 1) return -1;
 i += sizeof(p->cEndTimeYear);
 if (fwrite(&p->cEndTimeMonth, sizeof(p->cEndTimeMonth), 1, f) != 1) return -1;
 i += sizeof(p->cEndTimeMonth);
 if (fwrite(&p->cLeadTimeDay, sizeof(p->cLeadTimeDay), 1, f) != 1) return -1;
 i += sizeof(p->cLeadTimeDay);
 if (fwrite(&p->cLeadTime, sizeof(p->cLeadTime), 1, f) != 1) return -1;
 i += sizeof(p->cLeadTime);
 if (fwrite(&p->cRepeatType, sizeof(p->cRepeatType), 1, f) != 1) return -1;
 i += sizeof(p->cRepeatType);
 if (i != n*m) fwerr("NRA", i, n*m);
 return m;
}

int fread_NRA(NRA *p, int n, int m, FILE *f)
{
 int i = 0;
 if (fread(&p->iLength, sizeof(p->iLength), 1, f) != 1) return -1;
 i += sizeof(p->iLength);
 if (fread(&p->iOsCategory, sizeof(p->iOsCategory), 1, f) != 1) return -1;
 i += sizeof(p->iOsCategory);
 if (fread(&p->iOsLocation, sizeof(p->iOsLocation), 1, f) != 1) return -1;
 i += sizeof(p->iOsLocation);
 if (fread(&p->iOsRepeat, sizeof(p->iOsRepeat), 1, f) != 1) return -1;
 i += sizeof(p->iOsRepeat);
 if (fread(&p->iNoteRecNum, sizeof(p->iNoteRecNum), 1, f) != 1) return -1;
 i += sizeof(p->iNoteRecNum);
 if (fread(&p->iPrevRecNum, sizeof(p->iPrevRecNum), 1, f) != 1) return -1;
 i += sizeof(p->iPrevRecNum);
 if (fread(&p->iNextRecNum, sizeof(p->iNextRecNum), 1, f) != 1) return -1;
 i += sizeof(p->iNextRecNum);
 if (fread(&p->cFlags, sizeof(p->cFlags), 1, f) != 1) return -1;
 i += sizeof(p->cFlags);
 if (fread(&p->cYear, sizeof(p->cYear), 1, f) != 1) return -1;
 i += sizeof(p->cYear);
 if (fread(&p->cMonth, sizeof(p->cMonth), 1, f) != 1) return -1;
 i += sizeof(p->cMonth);
 if (fread(&p->cDay, sizeof(p->cDay), 1, f) != 1) return -1;
 i += sizeof(p->cDay);
 if (fread(&p->cStartTimePri1, sizeof(p->cStartTimePri1), 1, f) != 1) return -1;
 i += sizeof(p->cStartTimePri1);
 if (fread(&p->cStartTimePri2, sizeof(p->cStartTimePri2), 1, f) != 1) return -1;
 i += sizeof(p->cStartTimePri2);
 if (fread(&p->iEndDate, sizeof(p->iEndDate), 1, f) != 1) return -1;
 i += sizeof(p->iEndDate);
 if (fread(&p->cEndTimeYear, sizeof(p->cEndTimeYear), 1, f) != 1) return -1;
 i += sizeof(p->cEndTimeYear);
 if (fread(&p->cEndTimeMonth, sizeof(p->cEndTimeMonth), 1, f) != 1) return -1;
 i += sizeof(p->cEndTimeMonth);
 if (fread(&p->cLeadTimeDay, sizeof(p->cLeadTimeDay), 1, f) != 1) return -1;
 i += sizeof(p->cLeadTimeDay);
 if (fread(&p->cLeadTime, sizeof(p->cLeadTime), 1, f) != 1) return -1;
 i += sizeof(p->cLeadTime);
 if (fread(&p->cRepeatType, sizeof(p->cRepeatType), 1, f) != 1) return -1;
 i += sizeof(p->cRepeatType);
 if (i != n*m) frerr("NRA", i, n*m);
 return m;
}

int fwrite_RIA(RIA *p, int n, int m, FILE *f)
{
 int i = 0;
 if (fwrite(&p->cFreq, sizeof(p->cFreq), 1, f) != 1) return -1;
 i += sizeof(p->cFreq);
 if (fwrite(&p->Days, sizeof(p->Days), 1, f) != 1) return -1;
 i += sizeof(p->Days);
 if (fwrite(&p->Weeks, sizeof(p->Weeks), 1, f) != 1) return -1;
 i += sizeof(p->Weeks);
 if (fwrite(&p->Month1, sizeof(p->Month1), 1, f) != 1) return -1;
 i += sizeof(p->Month1);
 if (fwrite(&p->Month2, sizeof(p->Month2), 1, f) != 1) return -1;
 i += sizeof(p->Month2);
 if (fwrite(&p->cStartYear, sizeof(p->cStartYear), 1, f) != 1) return -1;
 i += sizeof(p->cStartYear);
 if (fwrite(&p->cStartMonth, sizeof(p->cStartMonth), 1, f) != 1) return -1;
 i += sizeof(p->cStartMonth);
 if (fwrite(&p->cStartDay, sizeof(p->cStartDay), 1, f) != 1) return -1;
 i += sizeof(p->cStartDay);
 if (fwrite(&p->cEndYear, sizeof(p->cEndYear), 1, f) != 1) return -1;
 i += sizeof(p->cEndYear);
 if (fwrite(&p->cEndMonth, sizeof(p->cEndMonth), 1, f) != 1) return -1;
 i += sizeof(p->cEndMonth);
 if (fwrite(&p->cEndDay, sizeof(p->cEndDay), 1, f) != 1) return -1;
 i += sizeof(p->cEndDay);
 if (fwrite(&p->cDelete, sizeof(p->cDelete), 1, f) != 1) return -1;
 i += sizeof(p->cDelete);
 if (i != n*m) fwerr("RIA", i, n*m);
 return m;
}

int fread_RIA(RIA *p, int n, int m, FILE *f)
{
 int i = 0;
 if (fread(&p->cFreq, sizeof(p->cFreq), 1, f) != 1) return -1;
 i += sizeof(p->cFreq);
 if (fread(&p->Days, sizeof(p->Days), 1, f) != 1) return -1;
 i += sizeof(p->Days);
 if (fread(&p->Weeks, sizeof(p->Weeks), 1, f) != 1) return -1;
 i += sizeof(p->Weeks);
 if (fread(&p->Month1, sizeof(p->Month1), 1, f) != 1) return -1;
 i += sizeof(p->Month1);
 if (fread(&p->Month2, sizeof(p->Month2), 1, f) != 1) return -1;
 i += sizeof(p->Month2);
 if (fread(&p->cStartYear, sizeof(p->cStartYear), 1, f) != 1) return -1;
 i += sizeof(p->cStartYear);
 if (fread(&p->cStartMonth, sizeof(p->cStartMonth), 1, f) != 1) return -1;
 i += sizeof(p->cStartMonth);
 if (fread(&p->cStartDay, sizeof(p->cStartDay), 1, f) != 1) return -1;
 i += sizeof(p->cStartDay);
 if (fread(&p->cEndYear, sizeof(p->cEndYear), 1, f) != 1) return -1;
 i += sizeof(p->cEndYear);
 if (fread(&p->cEndMonth, sizeof(p->cEndMonth), 1, f) != 1) return -1;
 i += sizeof(p->cEndMonth);
 if (fread(&p->cEndDay, sizeof(p->cEndDay), 1, f) != 1) return -1;
 i += sizeof(p->cEndDay);
 if (fread(&p->cDelete, sizeof(p->cDelete), 1, f) != 1) return -1;
 i += sizeof(p->cDelete);
 if (i != n*m) frerr("RIA", i, n*m);
 return m;
}

