#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "apptout.h"

extern FILE  *fp;
extern FILE  *fpout;
extern long  lFirst;
extern long  lFileLast;
extern short iFileType;
extern short iDebugG;
extern short iDebugG2;
extern short iCSV;
extern short iETC;
extern short iEvent;
extern short iAppt;
extern short iToDo;
extern short iSilent;
extern short iOutAppt;
extern short iDataNum;
extern short iMerge;
extern long  lLookUpSeek;

void ReadData(PFDC start_fdc, PSCSV start_scsv, PSINF *pSeekInfo)
{
  unsigned char	*szBuffer;
  unsigned char	szDate[4];
  char			*pszOut;
  char			cRepeatType;
  short			iSize, i;
  short			nKind;
  RHDR			rh;
  PCSVD			start_csvd, other_csvd, curr_csvd;
  PCSVD 		work_csvd,work2_csvd;
  PNRA			curr_nra;
  PRIA			curr_ria;
  short iPer, iPerMark = 0;

  if (iSilent < 2 && iFileType == 2){
	fprintf(stderr, " Pass-2  |");
  }

  while(1){

	/* Proccess print */
	if (iSilent < 2 && iFileType == 2){
	  iPer = (short)((double)ftell(fp)/(double)lFileLast*100.);
	  if (iPer < 100){
		for (i=2;i<=iPer - iPerMark;i=i+2){
		  fprintf(stderr, "o");
		}
	  }
      if (i>2)
		iPerMark = iPerMark+(i-2);
	}

    /* End of file */
    if (feof(fp)){
	  if (iSilent < 2 && iFileType == 2) fprintf(stderr, "|\n\n");
      break;
    }

    /* Read standard record header */
    if (fread_RHDR(&rh, 1, RHDR_SIZE, fp) != RHDR_SIZE){
	  if (iSilent < 2 && iFileType == 2) fprintf(stderr, "|\n\n");
      break;
    }

    if (rh.cType == TYPE_LOOKUPTABLE){ /* End of DATA */
	  if (iSilent < 2 && iFileType == 2) fprintf(stderr, "|\n\n");
      break;
/*    } else if(rh.cType == TYPE_DATA && !(rh.cStatus & 0x01)){*/
    } else if(rh.cType == TYPE_DATA){

      iSize = rh.iLength - RHDR_SIZE;  /* Data size */

	  /* Read data buffer */
      if ((szBuffer = (unsigned char *)malloc(iSize + 1)) == NULL){
        fprintf(stderr, "1. Not enough memory in ReadData.\n");
        exit(1);
      }

	  /* Initialize by NULL */
	  memset(szBuffer, '\0', iSize + 1);

      if (fread(szBuffer, 1, iSize, fp) != iSize){
        fprintf(stderr, "%ld\n", rh.iLength);
        fprintf(stderr, "2. Failed read TYPE_DATA in file.\n");
        exit(1);
      }
      szBuffer[iSize] = '\0';

	  /* If file type is appointment */
      if (iFileType == 2){

		/* Make CSVD struct */
		cRepeatType = szBuffer[26];
		curr_csvd = MakeCSVD((char)(cRepeatType-1));
		curr_ria = curr_csvd->pria;
		curr_nra = curr_csvd->pnra;

		nKind = szBuffer[14];  /* Kind of data */

		/* Now data of appointment */
		if (nKind >= 32){

		  /* Set read data to CSVD-structure */
		  ReadAppt(start_fdc, curr_csvd, szBuffer, nKind);

		/* Now data of todo */
	    }else if (nKind >=16 && nKind < 32){

		  /* Set read data to CSVD-structure */
	      ReadTodo(start_fdc, curr_csvd, szBuffer, nKind);
	    }

		/* Connect data chain */
		if (!(iMerge && iOutAppt))
		  AddUserType14(start_scsv, curr_csvd, pSeekInfo);

	  /* Database file */
      }else if(iFileType == 1){

		if ((pszOut = (char *)malloc(5120 + 1)) == NULL){
		  fprintf(stderr, "2. Not enough memory in ReadData.\n");
		  exit(1);
		}
		memset(pszOut, '\0', 5121);

		ReadDB(start_fdc, pSeekInfo, szBuffer, pszOut);

		if (iSilent%2 != 1 && !(iMerge && iOutAppt)){
		  fprintf(stdout, pszOut);
		}

		if (iDebugG2){
		  fprintf(stdout, "iSize=%d\n",iSize);
		  for(i=0;i<iSize;i++){
			if (i<30){
			  fprintf(stdout, "(%d)%d\n",i,  szBuffer[i+1]*256+szBuffer[i]);
			  i++;
			}else
			  fprintf(stdout, "(%d)%c\n",i,  szBuffer[i]);
		  }
		}

		/* Write old data */
		if (iOutAppt && !iMerge){
		  rh.iRecord = iDataNum;
	      AddSeekInfo(pSeekInfo, &rh, ftell(fpout));
	      iDataNum++;
          fwrite_RHDR(&rh, RHDR_SIZE, 1, fpout);
	      fwrite(szBuffer, iSize, 1, fpout);
		}

		free(pszOut);
      }

	  /* Allocated data free */
      free(szBuffer);
      
	}else{
      fseek(fp, rh.iLength - 6, SEEK_CUR);
    }
  }
}
