#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "apptout.h"

extern FILE   *fp;
extern FILE   *fpout;
extern long   lFirst;
extern short  iNoteNum;
extern short  iFileDefNum;
extern short  iDebugG;
extern short  iDebugG2;
extern short  iOutAppt;
extern short  iETC;
extern short  iMerge;

void ReadDB(PFDC start_fdc, PSINF *pSeekInfo, unsigned char *szBuffer,
			char *szOut)
{
  short		nOffset;
  short     iNoteLength;
  short     iCounter;
  short		word;
  char		*pszOut;
  char		szTime[20];
  RHDR		rh;
  PFDC		work_fdc;
  PFDEF		curr_fd;

  iCounter = 1;

  for(work_fdc=start_fdc; work_fdc; work_fdc=work_fdc->pnext_fdc){
	curr_fd = work_fdc->pfd;
	nOffset = curr_fd->iDataOffset;
/*
fprintf(stdout, "1.nOffset=%d, %s\n", nOffset, work_fdc->szName);
*/
	if (curr_fd->cFlags & 0x20)
	  nOffset = szBuffer[nOffset+1]*256+szBuffer[nOffset];
/*
fprintf(stdout, "2.nOffset=%d\n", nOffset);
*/
	switch(curr_fd->cFieldType){

	case 0:
	case 1:		/* Bitmasks */
		word = szBuffer[nOffset+1]*256+szBuffer[nOffset];
/*		word &= curr_fd->iReserved;*/
		if (iCounter == iFileDefNum)
		  PrintString((word ? "1" : "0"), szOut, FALSE);
		else
		  PrintString((word ? "1" : "0"), szOut, TRUE);
		iCounter++;
		break;
	case 2:		/* STRING_FIELD */
	case 3:		/* PHONE_FILED */
	case 4:		/* NUMBER_FIELD */
	case 5:		/* CURRENCY_FILED */
	case 6:		/* CATEGORY_FIELD */
	case 13:		/* MULTILINE_FILED */
	case 15:		/* COMBO_FILED */
		if (strlen(&szBuffer[nOffset])){
		  if (iCounter == iFileDefNum)
			PrintString(&szBuffer[nOffset], szOut, FALSE);
		  else
			PrintString(&szBuffer[nOffset], szOut, TRUE);
	    }else{
		  if (iCounter == iFileDefNum)
			PrintString("", szOut, FALSE);
		  else
			PrintString("", szOut, TRUE);
	    }
		iCounter++;
	    break;

	case 7:			/* Time */
		if (szBuffer[nOffset] == 0 && szBuffer[nOffset+1] == 0x80){
		  if (iCounter == iFileDefNum)
			PrintString("", szOut, FALSE);
		  else
			PrintString("", szOut, TRUE);
		  iCounter++;
		  break;	/* Empty time */
		}
		word = szBuffer[nOffset+1]*256+szBuffer[nOffset];
		sprintf(szTime, "%02d:%02d", word / 60, word % 60);
		if (iCounter == iFileDefNum)
		  PrintString(szTime, szOut, FALSE);
		else
		  PrintString(szTime, szOut, TRUE);
		iCounter++;
		break;

	case 8:			/* Date */
		if (szBuffer[nOffset] == 255 &&
		    szBuffer[nOffset+1] == 255 &&
		    szBuffer[nOffset+2] == 255){
		  if (iCounter == iFileDefNum)
			PrintString("", szOut, FALSE);
		  else
			PrintString("", szOut, TRUE);
		  iCounter++;
		  break;	/* Empty date */
		}
		sprintf(szTime, "%04d/%02d/%02d",
			szBuffer[nOffset]+1900,
			szBuffer[nOffset+1]+1,
			szBuffer[nOffset+2]+1);
		if (iCounter == iFileDefNum)
		  PrintString(szTime, szOut, FALSE);
		else
		  PrintString(szTime, szOut, TRUE);
		iCounter++;
		break;

	case 9:		/* Radio button */
		if (szBuffer[nOffset] == curr_fd->cReserved1){
		  if (iCounter == iFileDefNum)
			PrintString("1", szOut, FALSE);
		  else
			PrintString("1", szOut, TRUE);
		}else{
		  if (iCounter == iFileDefNum)
			PrintString("0", szOut, FALSE);
		  else
			PrintString("0", szOut, TRUE);
		}
		iCounter++;
		break;

	case 10:		/* Note */
		word = szBuffer[nOffset+1]*256+szBuffer[nOffset];
		if (word == -1){
		  if (iCounter == iFileDefNum)
			PrintString("", szOut, FALSE);
		  else
			PrintString("", szOut, TRUE);
		}else{
		  pszOut = ReadNote(word, 1);
		  if (iCounter == iFileDefNum)
			PrintString(pszOut, szOut, FALSE);
		  else
			PrintString(pszOut, szOut, TRUE); 

		  pszOut = ChangeString(pszOut);

		  if (iOutAppt && !iMerge){
		  	iNoteLength = strlen(pszOut);

			rh.cType = TYPE_NOTE;
			rh.cStatus = 0x01;
			rh.iLength = RHDR_SIZE + iNoteLength;
			rh.iRecord = iNoteNum; 
			szBuffer[nOffset] = iNoteNum % 0x100;
			szBuffer[nOffset+1] = iNoteNum / 0x100;

			AddSeekInfo(pSeekInfo, &rh, ftell(fpout));
			fwrite_RHDR(&rh, RHDR_SIZE, 1, fpout);
			fwrite(pszOut, iNoteLength, 1, fpout);
		    iNoteNum++;
		  }

		}
		iCounter++;
		break;
	}
  }
}
