#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "apptout.h"

extern FILE *fp;
extern FILE *fpout;
extern FILE *fpin;
extern short iFileType;
extern short iDebugG;
extern short iDebugG2;
extern short iCSV;
extern short iInCSV;
extern short iETC;
extern short iEvent;
extern short iAppt;
extern short iOutAppt;
extern short iToDo;
extern short iTAB;
extern short iNote;
extern short iHeader;
extern short iSilent;
extern short iMerge;
extern short iAlarm;
extern long  lCutStart;
extern long  lCutEnd;

int ReadOption(int iArg, char **ppArg)
{
  char 	szFilename[40];
  char 	szFilenameIN[40];
  char 	szFilenameOUT[40];
  short i, iLength;

  /* Read option and set flag */
  while((iArg>1) && ((ppArg[1][0] == '-') || (ppArg[1][0] == '/'))){
    switch(ppArg[1][1]){
    case 'x':
    case 'X':
      if (strlen(&ppArg[1][2]) != 0){
		strcpy(szFilename, &ppArg[1][2]);
      }else{
		ppArg++;
		iArg--;
		if ((ppArg[1][0] == '-') || (ppArg[1][0] == '/')){
		  fprintf(stderr, "Please, input filename!\n");
		  return(FALSE);
		}else{
		  strcpy(szFilename, &ppArg[1][0]);
		}
	  }
      break;
    case 'o':
    case 'O':
  	  iOutAppt = 1;
      if (strlen(&ppArg[1][2]) != 0)
		strcpy(szFilenameOUT, &(ppArg[1][2]));
      else{
		ppArg++;
		iArg--;
		if ((ppArg[1][0] == '-') || (ppArg[1][0] == '/')){
		  fprintf(stderr, "Please, Output filename!\n");
		  return(FALSE);
		}else{
		  strcpy(szFilenameOUT, &ppArg[1][0]);
		}
	  }
      break;
    case 'i':
    case 'I':
  	  iInCSV = 1;
      if (strlen(&ppArg[1][2]) != 0)
		strcpy(szFilenameIN, &ppArg[1][2]);
      else{
		ppArg++;
		iArg--;
		if ((ppArg[1][0] == '-') || (ppArg[1][0] == '/')){
		  fprintf(stderr, "Please, input CSV filename!\n");
		  return(FALSE);
		}else{
		  strcpy(szFilenameIN, &ppArg[1][0]);
		}
	  }
      break;
    case 'd':
    case 'D':
      if (strlen(&ppArg[1][2]) != 0)
		iDebugG2 = 1;
      else
        iDebugG = 1;
      break;
    case 'c':
    case 'C':
      iCSV = 2;
      if (strlen(&ppArg[1][2]) != 0){
        iCSV = atoi(&ppArg[1][2]);
        if (iCSV < 0 || 2 < iCSV)
		  iCSV = 0;
	  }
      break;
    case 'n':
    case 'N':
      iNote = 1;
      if (strlen(&ppArg[1][2]) != 0){
        iNote = atoi(&ppArg[1][2]);
        if (iNote < 0 || 2 < iNote)
		  iNote = 0;
	  }
      break;
    case 'g':
    case 'G':
      lCutStart = (long)atof(&ppArg[1][2]);
      if (strlen(&ppArg[1][2]) == 6){
        if (lCutStart < 101){
          lCutStart = 19000101;
          fprintf(stderr, "Check! Cut first date.(%ld)\n", lCutStart);
        }
        else if (101 <= lCutStart && lCutStart < 900000){
          lCutStart=lCutStart + 20000000;
        }
        else{
          lCutStart=lCutStart + 19000000;
        }
	  }else{
        if (lCutStart < 19000101 && 22000101 < lCutStart)
		  lCutStart = 19000101;
	  }
      break;
    case 'f':
    case 'F':
      lCutEnd = (long)atof(&ppArg[1][2]);
      if (strlen(&ppArg[1][2]) == 6){
        if (lCutEnd < 101){
          lCutEnd = 22000101;
          fprintf(stderr, "Check! Cut finish date.(%ld)\n", lCutEnd);
        }
        else if (101 <= lCutEnd && lCutEnd < 900000){
          lCutEnd = lCutEnd + 20000000;
        }
        else{
          lCutEnd = lCutEnd + 19000000;
        }
	  }else{
        if (lCutEnd < 19000101 && 22000101 < lCutEnd)
          lCutEnd = 22000101;
	  }
      break;
    case 'h':
    case 'H':
      iHeader = 1;
      break;
    case 'm':
    case 'M':
      iMerge = 1;
      break;
    case 's':
    case 'S':
      iSilent = 1;
      if (strlen(&ppArg[1][2]) != 0){
        iSilent = atoi(&ppArg[1][2])+1;
        if (iSilent < 0 || 3 < iSilent)
		  iSilent = 1;
	  }
      break;
    case 'a':
    case 'A':
      iAppt = 1;
      if (strlen(&ppArg[1][2]) != 0){
        iAppt = atoi(&ppArg[1][2]);
        if (iAppt == 0) iSilent = iAppt = 1;
        if (iAppt < 0 || 3 < iAppt) iAppt = 1;
	  }
      break;
    case 'e':
    case 'E':
      iAppt = 0;
      iEvent = 1;
      if (strlen(&ppArg[1][2]) != 0){
        iEvent = atoi(&ppArg[1][2]);
        if (iEvent == 0) iSilent = iEvent = 1;
        if (iEvent < 0 || 3 < iEvent)
		  iEvent = 1;
	  }
      break;
    case 't':
    case 'T':
      iAppt = 0;
      iToDo = 1;
      if (strlen(&ppArg[1][2]) != 0){
        iToDo = atoi(&ppArg[1][2]);
        if (iToDo == 0) iSilent = iToDo = 1;
        if (iToDo < 0 || 4 < iToDo) iToDo = 1;
	  }
      break;
    case 'r':
    case 'R':
      iAlarm = 7;
      if (strlen(&ppArg[1][2]) != 0){
        iAlarm = atoi(&ppArg[1][2]);
        if (iAlarm < 0 || 7 < iAlarm) iAlarm = 1;
	  }
      break;
    case '?':
      usage();
      return(FALSE);
    case 'b':
    case 'B':
      iTAB = 2;
      iCSV = 0;
      break;
    default:
      fprintf(stderr, "Bad option %s\n", ppArg[1]);
	  usage();
	  return(FALSE);
    }
    ppArg++;
    iArg--;
  }
  
  /* Datafile open */
  if ((fp = fopen(szFilename, "rb")) == NULL){
    fprintf(stderr, "File can't open.\n");
    return(FALSE);
  }

  /* Data in CSV file open */
  if (iInCSV && iFileType == 2){
	if ((fpin = fopen(szFilenameIN, "r")) == NULL){
      fprintf(stderr, "File can't open.\n");
      return(FALSE);
	}
  }
  
  /* Data out file open */
  if (iOutAppt){
	if ((fpout = fopen(szFilenameOUT, "wb")) == NULL){
      fprintf(stderr, "File can't open.\n");
      return(FALSE);
	}
  }
  return(TRUE);
}
