#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "apptout.h"

extern FILE   *fp;
extern long   lFirst;
extern short  iDebugG;
extern short  iDebugG2;
extern short  iETC;

char * ReadTodo(PFDC start_fdc, PCSVD curr_csvd, unsigned char *szBuffer,
               short nKindOrig)
{
  char	*pszWord;
  char	*pszData;
  char	cRepeatType;
  short	i, iSize;
  short nKind;
  short	nOffset;
  short	word;
  short	nComplete = 0;
  short	nCarry = 0;
  short	iLength;
  short iOsCategory;
  short	iOsLocation;
  short	iOsRepeat;
  short	iNoteRecNum;
  short	iPrevRecNum;
  short	iNextRecNum;
  char	cFreq;
  short iDays;
  short iMonth;
  unsigned char cStartYear;
  unsigned char cStartMonth;
  unsigned char cStartDay;
  unsigned char cEndYear;
  unsigned char cEndMonth;
  unsigned char cEndDay;
  PNRA	curr_nra;
  PRIA	curr_ria;

  /* Get CSVD structure */
  curr_nra = curr_csvd->pnra;
  curr_ria = curr_csvd->pria;

  /* Read information for record */
  curr_nra->cRepeatType = cRepeatType = szBuffer[26];
  curr_nra->iLength     = iLength     = szBuffer[1]*256+szBuffer[0];
  curr_nra->iOsCategory = iOsCategory = szBuffer[3]*256+szBuffer[2];
  curr_nra->iOsLocation = iOsLocation = szBuffer[5]*256+szBuffer[4];
  curr_nra->iOsRepeat   = iOsRepeat   = szBuffer[7]*256+szBuffer[6];
  curr_nra->iNoteRecNum = iNoteRecNum = szBuffer[9]*256+szBuffer[8];
  curr_nra->iPrevRecNum = iPrevRecNum = -1;
  curr_nra->iNextRecNum = iNextRecNum = -1;

  if (iDebugG){
	fprintf(stdout, " Item Length : %d\n",			iLength);
	fprintf(stdout, " Offset to Category : %d\n", 	iOsCategory);
	fprintf(stdout, " Offset to Location : %d\n", 	iOsLocation);
	fprintf(stdout, " Offset to Repeat : %d\n",		iOsRepeat);
	fprintf(stdout, " Note record# : %d\n",			iNoteRecNum);
	fprintf(stdout, " Prev record# : %d\n",			iPrevRecNum);
	fprintf(stdout, " Next record# : %d\n",			iNextRecNum);
	fprintf(stdout, " Repeat Status : %d\n",		cRepeatType);
  }

  curr_csvd->cKind = 16;
  curr_nra->cFlags = nKind = nKindOrig;
  nKind = nKind - 16;
  if (nKind / 4){
	nCarry = 1;
	nKind = nKind % 4;
  }
  if (nKind / 2){
	nComplete = 1;
	nKind = nKind % 2;
  }

  /* Note */
  if (iNoteRecNum == -1)
	pszData = GetString("");
  else{
	pszData = ReadNote(iNoteRecNum, cRepeatType);
    pszData = ChangeString(pszData);
  }
  curr_csvd->pszNote = pszData;

  /* Start Date */
  curr_nra->cYear = szBuffer[15];
  curr_nra->cMonth = szBuffer[16];
  curr_nra->cDay = szBuffer[17];

  /* Priority */
  curr_nra->cStartTimePri1 = szBuffer[18];
  curr_nra->cStartTimePri2 = szBuffer[19];

  /* Date's */
  word = szBuffer[21]*256+szBuffer[20];
  curr_nra->iEndDate = word;

  /* Complete Date */
  curr_nra->cEndTimeYear = szBuffer[22];
  curr_nra->cEndTimeMonth = szBuffer[23];
  curr_nra->cLeadTimeDay = szBuffer[24];
  curr_nra->cLeadTime = 0;

  /* Description */
  pszData = GetString(&szBuffer[27]);
  curr_csvd->pszDescription = pszData;

  /* Location */
  curr_csvd->pszLocation = GetString(""); /* Get 1 byte char */

  /* Category */
  curr_csvd->pszCategory = GetString(""); /* Get 1 byte char */

  /* Set repeat information appt to RIA */
  if (cRepeatType > 1){

    curr_ria->cFreq = szBuffer[iOsRepeat];
    curr_ria->Days = szBuffer[iOsRepeat+1];
    curr_ria->Weeks = szBuffer[iOsRepeat+2];
    curr_ria->Month1 = szBuffer[iOsRepeat+3];
    curr_ria->Month2 = szBuffer[iOsRepeat+4];
    curr_ria->cStartYear = szBuffer[iOsRepeat+5];
    curr_ria->cStartMonth = szBuffer[iOsRepeat+6];
    curr_ria->cStartDay = szBuffer[iOsRepeat+7];
    curr_ria->cEndYear = szBuffer[iOsRepeat+8];
    curr_ria->cEndMonth = szBuffer[iOsRepeat+9];
    curr_ria->cEndDay = szBuffer[iOsRepeat+10];
    curr_ria->cDelete = szBuffer[iOsRepeat+11];

    if (curr_ria->cDelete){
      iSize = curr_ria->cDelete * 4;
	  if ((pszWord = (char *)malloc(iSize + 1)) == NULL){
		fprintf(stderr, "Not enough memory in ReadToDo.\n");
		exit(1);
	  }
      for(i=0;i<iSize;i++){
    	pszWord[i]=szBuffer[iOsRepeat+12+i];
      }
      pszWord[iSize] = '\0';
      curr_csvd->pszDelRepeat = pszWord;
    }else
      curr_csvd->pszDelRepeat = NULL;

	if (iDebugG){
	  fprintf(stdout, "cFreq  : %d\n", curr_ria->cFreq);
	  iDays = curr_ria->Weeks*256+curr_ria->Days;
	  fprintf(stdout, "iDays  : %s\n", ReadRepeatDay(iDays));
	  iMonth = curr_ria->Month2*256+curr_ria->Month1;
	  fprintf(stdout, "iMonth : %d, %d:%d\n", 
			iMonth, iMonth/256, iMonth%256);
	  fprintf(stdout, "Start  : %d/%02d/%02d\n",
			curr_ria->cStartYear+1900,
			curr_ria->cStartMonth+1,
			curr_ria->cStartDay+1);
	  fprintf(stdout, "End    : %d/%02d/%02d\n",
			curr_ria->cEndYear+1900,
			curr_ria->cEndMonth+1,
			curr_ria->cEndDay+1);
	  fprintf(stdout, "cDelete: %d\n", curr_ria->cDelete);
	  if (curr_ria->cDelete){
		for(i=0;i<curr_ria->cDelete*4;i++)
		  fprintf(stdout, "%d\n", pszWord[i]);
	  }
	}
  }
  return(NULL);
}
