#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "apptout.h"

extern short iTAB;

void CSVToNRAAppt(PCSVD curr_csvd, unsigned char *szBuffer, short nKind)
{
  short			i;
  short			iSize;
  short			iNum;
  short			iMinute;
  short			iDay;
  short			iMonth;
  char			cFreq;
  char			*pszData;
  unsigned char cYear, cMonth, cDay;
  unsigned short iEndDate;
  PNRA			curr_nra;
  PRIA			curr_ria;
  
  curr_nra = curr_csvd->pnra;
  curr_ria = curr_csvd->pria;

  cFreq = 0;
  iDay = 0;
  iMonth = 0;

  /* check field number */
  iSize = strlen(szBuffer);
  iNum=1;
  for (i=0;i<iSize;i++){
	if (iTAB){
	  if (szBuffer[i] == '\t') iNum++;
	}else{
	  if (szBuffer[i] == ',') iNum++;
	}
  }

  if (iNum < 7){
	fprintf(stderr, "I can't understand follow this record. Please check !\n");
	fprintf(stderr, "<<< %s >>>\n", szBuffer);
  }

  for (i = 1; i < iNum+1; i++){
    pszData = GetCSV(szBuffer, i, '\"');
    switch(i){
    case 1:	/* Description */
      CutString(pszData, 0, 51);
      curr_csvd->pszDescription = pszData;
      break;
    case 2:	/* Start Date */
      if (strlen(pszData)){
		cYear = (char)(atoi(strtok(pszData, "/")) - 1900);
		cMonth = (char)(atoi(strtok(NULL, "/")) - 1);
		cDay = (char)(atoi(strtok(NULL, "/")) - 1);
      }else{
		cYear = 255;
		cMonth = 255;
		cDay = 255;
      }
      curr_nra->cYear = cYear;
      curr_nra->cMonth = cMonth;
      curr_nra->cDay = cDay;
      free(pszData);
      break;
    case 3:	/* Start Time */
      if (strlen(pszData)){
		if (!strstr(pszData, "NONE") || !strstr(pszData, "none")){
		  iMinute = atoi(strtok(pszData, ":")) * 60;
		  iMinute = atoi(strtok(NULL, ":")) + iMinute;
		  curr_csvd->iStartTimeFlag = 0;
		  curr_nra->cStartTimePri1 = iMinute % 0x100;
		  curr_nra->cStartTimePri2 = iMinute / 0x100;
		}else{
		  curr_csvd->iStartTimeFlag = 1;
		  curr_nra->cStartTimePri1 = 255;
		  curr_nra->cStartTimePri2 = 255;
		}
      }else{
		curr_csvd->iStartTimeFlag = 1;
		curr_nra->cStartTimePri1 = 255;
		curr_nra->cStartTimePri2 = 255;
      }
      free(pszData);
      break;
    case 4:	/* End Time */
      if (strlen(pszData)){
		if (!strstr(pszData, "NONE") || !strstr(pszData, "none")){
		  iMinute = atoi(strtok(pszData, ":")) * 60;
		  iMinute = atoi(strtok(NULL, ":")) + iMinute;
		  curr_csvd->iEndTimeFlag = 0;
		  curr_nra->cEndTimeYear = iMinute % 0x100;
		  curr_nra->cEndTimeMonth = iMinute / 0x100;
		}else{
		  curr_csvd->iEndTimeFlag = 1;
		  curr_nra->cEndTimeYear = 255;
		  curr_nra->cEndTimeMonth = 255;
		}
      }else{
		curr_csvd->iEndTimeFlag = 1;
		curr_nra->cEndTimeYear = 255;
		curr_nra->cEndTimeMonth = 255;
      }
      free(pszData);
      break;
    case 5:	/*Location */
      CutString(pszData, 0, 19);
      curr_csvd->pszLocation = pszData;
      break;
    case 6:	/* End Date */
      if (strlen(pszData)){
		iEndDate = atoi(pszData);
      }else{
		iEndDate = 0;
      }
      curr_nra->iEndDate = iEndDate;
      free(pszData);
      break;
    case 7:	/* Note */
      pszData = ChangeString(pszData);
      curr_csvd->pszNote = pszData;
      if (!strlen(pszData))
		curr_nra->iNoteRecNum = -1;
      break;
    case 8: /* cFrequency */
      if (curr_ria){
		if (strlen(pszData))
		  curr_ria->cFreq = cFreq = atoi(pszData);
		else
		  curr_ria->cFreq = 0;
	  }
	  free(pszData);
      break;
    case 9: /* Days */
      if (curr_ria){
        if (strlen(pszData)){
          iDay = GetRepeatDay(pszData);
          curr_ria->Days = iDay % 256;
          curr_ria->Weeks = iDay / 256;
		}else{
          curr_ria->Days = 0;
          curr_ria->Weeks = 0;
        }
      }
	  free(pszData);
      break;
    case 10: /* Days */
      if (curr_ria){
        if (strlen(pszData)){
          iMonth = GetRepeatMonth(pszData);
          curr_ria->Month1 = iMonth % 256;
          curr_ria->Month2 = iMonth / 256;
		}else{
          curr_ria->Month1 = 0;
          curr_ria->Month2 = 0;
        }
      }
	  free(pszData);
      break;
    case 11:	/* Start Date */
      if (curr_ria){
		if (strlen(pszData)){
		  cYear = (char)(atoi(strtok(pszData, "/")) - 1900);
		  cMonth = (char)(atoi(strtok(NULL, "/")) - 1);
		  cDay = (char)(atoi(strtok(NULL, "/")) - 1);
		}else{
		  cYear = 255;
		  cMonth = 255;
		  cDay = 255;
		}
		curr_ria->cStartYear = cYear;
		curr_ria->cStartMonth = cMonth;
		curr_ria->cStartDay = cDay;
      }
      free(pszData);
      break;
    case 12:	/* End Date */
      if (curr_ria){
		if (strlen(pszData)){
		  cYear = (char)(atoi(strtok(pszData, "/")) - 1900);
		  cMonth = (char)(atoi(strtok(NULL, "/")) - 1);
		  cDay = (char)(atoi(strtok(NULL, "/")) - 1);
		}else{
		  cYear = 255;
		  cMonth = 255;
		  cDay = 255;
		}
		curr_ria->cEndYear = cYear;
		curr_ria->cEndMonth = cMonth;
		curr_ria->cEndDay = cDay;
      }
      free(pszData);
      break;
    }
  }

  if (curr_ria){
	switch(iNum){
	case 8:
	  curr_ria->Days = 0;
	  curr_ria->Weeks = 0;
	case 9:
	  curr_ria->Month1 = 0;
	  curr_ria->Month2 = 0;
	case 10:
	  curr_ria->cStartYear = 94;
	  curr_ria->cStartMonth = 0;
	  curr_ria->cStartDay = 0;
	case 11:
	  curr_ria->cEndYear = 99;
	  curr_ria->cEndMonth = 0;
	  curr_ria->cEndDay = 0;
	}
  }

  /* Set repeat type */
  if (cFreq == 0 && iDay == 0 && iMonth == 0)
	curr_nra->cRepeatType = 1;	/* Non repeat */
  else if (cFreq != 0 && iDay == 0 && iMonth == 0)
	curr_nra->cRepeatType = 2;	/* Day repeat */
  else if (cFreq != 0 && (iDay > 128 || iDay < 256) && iMonth == 0)
	curr_nra->cRepeatType = 4;	/* Week repeat */
  else if (cFreq != 0 && (iDay < 128 || iDay > 256) && iMonth == 0)
	curr_nra->cRepeatType = 8;	/* Month repeat */
  else if (cFreq != 0 && (iDay < 128 || iDay > 256) && iMonth != 0)
	curr_nra->cRepeatType = 16;	/* Year repeat */
  else if (cFreq == 0 && (iDay < 128 || iDay > 256) && iMonth != 0)
	curr_nra->cRepeatType = 32; /* Custom repeat */

  /* Set other infomation */
  curr_nra->iPrevRecNum = -1;
  curr_nra->iNextRecNum = -1;
  curr_nra->cFlags = nKind;
  curr_nra->cLeadTimeDay = 5 % 0x100;
  curr_nra->cLeadTime = 5 / 0x100;
  curr_csvd->pszCategory = GetCSV("", 1, ','); /* Get 1 byte char */
  
}
