#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "apptout.h"

extern short iTAB;

void CSVToNRAToDo(PCSVD curr_csvd, unsigned char *szBuffer, short nKind)
{
  short			i;
  short			iSize;
  short			iNum;
  short			nComplete;
  short			iDay;
  short			iMonth;
  char			cFreq;
  char			*pszData;
  unsigned char cYear, cMonth, cDay;
  short 		iMinute;
  unsigned short iEndDate;
  PNRA			curr_nra;
  PRIA			curr_ria;
  
  curr_nra = curr_csvd->pnra;
  curr_ria = curr_csvd->pria;
  
  cFreq = 0;
  iDay = 0;
  iMonth = 0;

  iSize = strlen(szBuffer);
  iNum=1;
  for (i=0;i<iSize;i++){
	if (iTAB){
	  if (szBuffer[i] == '\t') iNum++;
	}else{
	  if (szBuffer[i] == ',') iNum++;
	}
  }

  for (i = 1; i < iNum+1; i++){
    pszData = GetCSV(szBuffer, i, '\"');
    switch(i){
    case 1:	/* Description */
      CutString(pszData, 0, 51);
      curr_csvd->pszDescription = pszData;
      break;
    case 2:	/* Start Date */
      if (strlen(pszData)){
		cYear = (char)(atoi(strtok(pszData, "/")) - 1900);
		cMonth = (char)(atoi(strtok(NULL, "/")) - 1);
		cDay = (char)(atoi(strtok(NULL, "/")) - 1);
      }else{
		cYear = 255;
		cMonth = 255;
		cDay = 255;
      }
      curr_nra->cYear = cYear;
      curr_nra->cMonth = cMonth;
      curr_nra->cDay = cDay;
      free(pszData);
      break;
    case 3:	/* Due date */
      if (strlen(pszData)){
		iEndDate = (unsigned short)atoi(pszData);
      }else{
		iEndDate = 0;
      }
      curr_nra->iEndDate = iEndDate;
      free(pszData);
      break;
    case 4:	/* Completed Date */
      if (strlen(pszData)){
		nComplete = 2;
		cYear = (char)(atoi(strtok(pszData, "/")) - 1900);
		cMonth = (char)(atoi(strtok(NULL, "/")) - 1);
		cDay = (char)(atoi(strtok(NULL, "/")) - 1);
      }else{
		nComplete = 0;
		cYear = 255;
		cMonth = 255;
		cDay = 255;
      }
      curr_nra->cEndTimeYear = cYear;
      curr_nra->cEndTimeMonth = cMonth;
      curr_nra->cLeadTimeDay = cDay;
      free(pszData);
      break;
    case 5:	/* Priority */
      if (strlen(pszData)){
		curr_nra->cStartTimePri1 = pszData[0];
		curr_nra->cStartTimePri2 = '\0';
      }else{
		curr_nra->cStartTimePri1 = '1';
		curr_nra->cStartTimePri2 = '\0';
      }
      free(pszData);
      break;
    case 6:	/* Note */
      pszData = ChangeString(pszData);
      curr_csvd->pszNote = pszData;
      if (!strlen(pszData))
		curr_nra->iNoteRecNum = -1;
      break;
    case 7: /* cFrequency */
      if (curr_ria){
		if (strlen(pszData))
		  curr_ria->cFreq = cFreq = atoi(pszData);
		else
		  curr_ria->cFreq = 0;
	  }
      break;
    case 8: /* Days */
      if (curr_ria){
        if (strlen(pszData)){
          iDay = GetRepeatDay(pszData);
          curr_ria->Days = iDay % 256;
          curr_ria->Weeks = iDay / 256;
		}else{
          curr_ria->Days = 0;
          curr_ria->Weeks = 0;
        }
      }
      break;
    case 9: /* Days */
      if (curr_ria){
        if (strlen(pszData)){
          iMonth = GetRepeatMonth(pszData);
          curr_ria->Month1 = iMonth % 256;
          curr_ria->Month2 = iMonth / 256;
		}else{
          curr_ria->Month1 = 0;
          curr_ria->Month2 = 0;
        }
      }
      break;
    case 10:	/* Start Date */
      if (curr_ria){
		if (strlen(pszData)){
		  cYear = (char)(atoi(strtok(pszData, "/")) - 1900);
		  cMonth = (char)(atoi(strtok(NULL, "/")) - 1);
		  cDay = (char)(atoi(strtok(NULL, "/")) - 1);
		}else{
		  cYear = 255;
		  cMonth = 255;
		  cDay = 255;
		}
		curr_ria->cStartYear = cYear;
		curr_ria->cStartMonth = cMonth;
		curr_ria->cStartDay = cDay;
      }
      free(pszData);
      break;
    case 11:	/* End Date */
      if (curr_ria){
		if (strlen(pszData)){
		  cYear = (char)(atoi(strtok(pszData, "/")) - 1900);
		  cMonth = (char)(atoi(strtok(NULL, "/")) - 1);
		  cDay = (char)(atoi(strtok(NULL, "/")) - 1);
		}else{
		  cYear = 255;
		  cMonth = 255;
		  cDay = 255;
		}
		curr_ria->cEndYear = cYear;
		curr_ria->cEndMonth = cMonth;
		curr_ria->cEndDay = cDay;
      }
      free(pszData);
      break;
    }
  }

  /* Set repeat type */
  if (cFreq == 0 && iDay == 0 && iMonth == 0)
	curr_nra->cRepeatType = 1;	/* Non repeat */
  else if (cFreq != 0 && iDay == 0 && iMonth == 0)
	curr_nra->cRepeatType = 2;	/* Day repeat */
  else if (cFreq != 0 && (iDay > 128 || iDay < 256) && iMonth == 0)
	curr_nra->cRepeatType = 4;	/* Week repeat */
  else if (cFreq != 0 && (iDay < 128 || iDay > 256) && iMonth == 0)
	curr_nra->cRepeatType = 8;	/* Month repeat */
  else if (cFreq != 0 && (iDay < 128 || iDay > 256) && iMonth != 0)
	curr_nra->cRepeatType = 16;	/* Year repeat */
  else if (cFreq == 0 && (iDay < 128 || iDay > 256) && iMonth != 0)
	curr_nra->cRepeatType = 32; /* Custom repeat */

  /* Set other infomation */
  curr_nra->iPrevRecNum = -1;
  curr_nra->iNextRecNum = -1;
  curr_nra->cFlags = nKind + nComplete;
  curr_nra->cLeadTime = -1;
  curr_csvd->pszLocation = GetCSV("", 1, ','); /* Get 1 byte char */
  curr_csvd->pszCategory = GetCSV("", 1, ','); /* Get 1 byte char */
  
}
