#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "apptout.h"

extern FILE *fpout;
extern short iAppt;
extern short iEvent;
extern short iToDo;
extern short iNote;
extern short iFileType;

void WriteCSV(PCSVD curr_csvd)
{
  char	szCSV[BUF];
  char	szStartDate[11];
  char	szStartDateR[11];
  char	szStartTime[6];
  char	szEndTime[6];
  char	szEndDate[11];
  char	szEndDateR[11];
  char  szPriority[3];
  char  szWeek[30];
  char  szMonth[50];
  char  szFreq[5];
  char  szDelete[5];
  char  *pszNote, *pszW;
  short iTime;
  short iSize;
  short i;
  PNRA	curr_nra;
  PRIA	curr_ria;
  char	cFreq;
  short iDays;
  short iMonth;
  unsigned char cStartYear;
  unsigned char cStartMonth;
  unsigned char cStartDay;
  unsigned char cEndYear;
  unsigned char cEndMonth;
  unsigned char cEndDay;
  char	cDelete;

  memset(szCSV, '\0', BUF);

  curr_nra = curr_csvd->pnra;
  curr_ria = curr_csvd->pria;

  if (iFileType == 2){
    if (iAppt || iEvent){

	  /* Description */
	  if (strlen(curr_csvd->pszDescription)){
	    PrintString(curr_csvd->pszDescription, szCSV, TRUE);
	  }else
	    PrintString("", szCSV, TRUE);

	  /* Start date */
	  if (curr_nra->cYear<255 && curr_nra->cMonth<255 && curr_nra->cDay<255){
        sprintf(szStartDate, "%04d/%02d/%02d",
	      curr_nra->cYear+1900,	/* year */
	      curr_nra->cMonth+1,	/* month */
	      curr_nra->cDay+1);	/* day */
        PrintString(szStartDate, szCSV, TRUE);
      }else
        PrintString("", szCSV, TRUE);

	  /* Start time */
	  if (curr_nra->cStartTimePri1==0 || curr_nra->cStartTimePri2==0x80){
        PrintString("NONE", szCSV, TRUE);
	  }else{
		iTime = curr_nra->cStartTimePri2*256+curr_nra->cStartTimePri1;
		if (iTime < 0){
		  PrintString("NONE", szCSV, TRUE);
		}else{
		  sprintf(szStartTime, "%02d:%02d", iTime/60, iTime%60);
		  PrintString(szStartTime, szCSV, TRUE);
		}
      }

	  /* End time */
	  if (curr_nra->cEndTimeYear==0 || curr_nra->cEndTimeMonth==0x80){
        PrintString("NONE", szCSV, TRUE);
      }else{
	    iTime = curr_nra->cEndTimeMonth*256+curr_nra->cEndTimeYear;
		if (iTime < 0){
		  PrintString("NONE", szCSV, TRUE);
		}else{
		  sprintf(szEndTime, "%02d:%02d", iTime/60, iTime%60);
		  PrintString(szEndTime, szCSV, TRUE);
		}
	  }

	  /* Location */
	  if (strlen(curr_csvd->pszLocation)){
	    PrintString(curr_csvd->pszLocation, szCSV, TRUE);
	  }else
	    PrintString("", szCSV, TRUE);

	  /* Consecutive days */
	  sprintf(szEndDate, "%d", curr_nra->iEndDate);
	  PrintString(szEndDate, szCSV, TRUE);

	  /* Note */
	  if (iSize=strlen(curr_csvd->pszNote)){
	    if ((pszNote = (char *)malloc(iSize + 1)) == NULL){
    	  fprintf(stderr, "1. Not enough memory in WriteCSV.\n");
	      exit(1);
	    }
    	pszNote[iSize] = '\0';

		pszW = curr_csvd->pszNote;

		if (iNote == 1){
		  for(i = 0; i<iSize; i++){
			if (pszW[i] == '\r' || pszW[i] == '\n')
			  pszNote[i] = ' ';
			else
			  pszNote[i] = pszW[i];
		  }
		}else if (iNote == 2){
		  for(i = 0; i<iSize; i++){
			if (pszW[i] == '\r')
			  pszNote[i] = '\\';
			else if (pszW[i] == '\n')
			  pszNote[i] = 'n';
			else
			  pszNote[i] = pszW[i];
		  }
		}else{
		  strcpy(pszNote, pszW);
		}

		if (curr_nra->cRepeatType > 1)
		  PrintString(pszNote, szCSV, TRUE);
		else
		  PrintString(pszNote, szCSV, FALSE);
		free(pszNote);
	  }else
		if (curr_nra->cRepeatType > 1)
		  PrintString("", szCSV, TRUE);
		else
		  PrintString("", szCSV, FALSE);

	  /* Repeat infomation */
	  if (curr_nra->cRepeatType > 1){

		cFreq = curr_ria->cFreq;
		iDays = curr_ria->Weeks*256+curr_ria->Days;
		iMonth = curr_ria->Month2*256+curr_ria->Month1;
		cStartYear = curr_ria->cStartYear;
		cStartMonth = curr_ria->cStartMonth;
		cStartDay = curr_ria->cStartDay;
		cEndYear = curr_ria->cEndYear;
		cEndMonth = curr_ria->cEndMonth;
		cEndDay = curr_ria->cEndDay;
		cDelete = curr_ria->cDelete;

		sprintf(szFreq, "%d", cFreq);
		PrintString(szFreq, szCSV, TRUE);
		sprintf(szWeek, "%s", ReadRepeatDay(iDays));
		PrintString(szWeek, szCSV, TRUE);
		sprintf(szMonth, "%s", ReadRepeatMonth(iMonth));
		PrintString(szMonth, szCSV, TRUE);
		sprintf(szStartDateR, "%4d/%02d/%02d",
			cStartYear+1900, cStartMonth+1, cStartDay+1);
		PrintString(szStartDateR, szCSV, TRUE);
		sprintf(szEndDateR, "%4d/%02d/%02d",
			cEndYear+1900, cEndMonth+1, cEndDay+1);
		PrintString(szEndDateR, szCSV, TRUE);
		sprintf(szDelete, "%d", cDelete);
		PrintString(szDelete, szCSV, FALSE);
	  }

	}else if(iToDo){

	  /* Description */
	  if (strlen(curr_csvd->pszDescription)){
	    PrintString(curr_csvd->pszDescription, szCSV, TRUE);
	  }else
	    PrintString("", szCSV, TRUE);

	  /* Start date */
	  if (curr_nra->cYear<255 && curr_nra->cMonth<255 && curr_nra->cDay<255){
        sprintf(szStartDate, "%04d/%02d/%02d",
	      curr_nra->cYear+1900,	/* year */
	      curr_nra->cMonth+1,	/* month */
	      curr_nra->cDay+1);	/* day */
        PrintString(szStartDate, szCSV, TRUE);
      }else
        PrintString("", szCSV, TRUE);

	  if (iToDo == 4){

        PrintString("", szCSV, TRUE);
        PrintString("", szCSV, TRUE);
        PrintString("", szCSV, TRUE);

		/* Consecutive days */
		sprintf(szEndDate, "%d", curr_nra->iEndDate);
		PrintString(szEndDate, szCSV, TRUE);

	  }else{

		/* Consecutive days */
		sprintf(szEndDate, "%d", curr_nra->iEndDate);
		PrintString(szEndDate, szCSV, TRUE);

		/* Completion date */
		if (curr_nra->cEndTimeYear<255 && 
			curr_nra->cEndTimeMonth<255 &&
			curr_nra->cLeadTimeDay<255){
		  sprintf(szStartDate, "%04d/%02d/%02d",
			curr_nra->cEndTimeYear+1900,	/* year */
			curr_nra->cEndTimeMonth+1,	/* month */
			curr_nra->cLeadTimeDay+1);	/* day */
		  PrintString(szStartDate, szCSV, TRUE);
		}else
		  PrintString("", szCSV, TRUE);

		/* Priority */
		szPriority[0] = curr_nra->cStartTimePri1;
		szPriority[1] = curr_nra->cStartTimePri2;
		szPriority[2] = '\0';
		PrintString(szPriority, szCSV, TRUE);

	  }

	  /* Note */
	  if (iSize=strlen(curr_csvd->pszNote)){
		if ((pszNote = (char *)malloc(iSize + 1)) == NULL){
		  fprintf(stderr, "2. Not enough memory in WriteCSV.\n");
		  exit(1);
		}
		pszNote[iSize] = '\0';

		pszW = curr_csvd->pszNote;

		if (iNote == 1){
		  for(i = 0; i<iSize; i++){
			if (pszW[i] == '\r' || pszW[i] == '\n')
			  pszNote[i] = ' ';
			else
			  pszNote[i] = pszW[i];
		  }
		}else if (iNote == 2){
		  for(i = 0; i<iSize; i++){
			if (pszW[i] == '\r')
			  pszNote[i] = '\\';
			else if (pszW[i] == '\n')
			  pszNote[i] = 'n';
			else
			  pszNote[i] = pszW[i];
		  }
		}else{
		  strcpy(pszNote, pszW);
		}

		if (curr_nra->cRepeatType > 1)
		  PrintString(pszNote, szCSV, TRUE);
		else
		  PrintString(pszNote, szCSV, FALSE);
		free(pszNote);
	  }else
		if (curr_nra->cRepeatType > 1)
		  PrintString("", szCSV, TRUE);
		else
		  PrintString("", szCSV, FALSE);

	  /* Repeat infomation */
	  if (curr_nra->cRepeatType > 1){

		cFreq = curr_ria->cFreq;
		iDays = curr_ria->Weeks*256+curr_ria->Days;
		iMonth = curr_ria->Month2*256+curr_ria->Month1;
		cStartYear = curr_ria->cStartYear;
		cStartMonth = curr_ria->cStartMonth;
		cStartDay = curr_ria->cStartDay;
		cEndYear = curr_ria->cEndYear;
		cEndMonth = curr_ria->cEndMonth;
		cEndDay = curr_ria->cEndDay;
		cDelete = curr_ria->cDelete;

		sprintf(szFreq, "%d", cFreq);
		PrintString(szFreq, szCSV, TRUE);
		sprintf(szWeek, "%s", ReadRepeatDay(iDays));
		PrintString(szWeek, szCSV, TRUE);
		sprintf(szMonth, "%s", ReadRepeatMonth(iMonth));
		PrintString(szMonth, szCSV, TRUE);
		sprintf(szStartDateR, "%4d/%02d/%02d",
			cStartYear+1900, cStartMonth+1, cStartDay+11);
		PrintString(szStartDateR, szCSV, TRUE);
		sprintf(szEndDateR, "%4d/%02d/%02d",
			cEndYear+1900, cEndMonth+1, cEndDay+1);
		PrintString(szEndDateR, szCSV, TRUE);
		sprintf(szDelete, "%d", cDelete);
		PrintString(szDelete, szCSV, FALSE);
	  }

	}
	fprintf(stdout, szCSV);
  }
}
