#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "apptout.h"

extern FILE *fpout;
extern short iDebugG;
extern short iAppt;

void WriteDATA(PCSVD pcsvd, PSINF *pSeekInfo)
{
  short		iDescLength;
  short		iCateLength;
  short		iLocaLength;
  short		iNoteLength;
  short		iRepeLength;
  short		iDelRLength;
  short		iSum;
  unsigned char szDate[4];
  RHDR		rh;
  PCSVD		work_csvd;
  PNRA		work_nra;
  PRIA		work_ria;
  PSINF		work_sinf;

  work_csvd=pcsvd;
  work_nra = work_csvd->pnra;
  work_ria = work_csvd->pria;

  iDescLength = strlen(work_csvd->pszDescription) + 1;
  iCateLength = strlen(work_csvd->pszCategory) + 1;
  iLocaLength = strlen(work_csvd->pszLocation) + 1;
  if (work_nra->cRepeatType > 1){
	iRepeLength = 12;
	if (work_ria->cDelete){
	  iDelRLength = 4 * work_ria->cDelete;
	  iRepeLength = iRepeLength + iDelRLength;
	}
  }else
    iRepeLength = 0;

  /* Make record header */
  rh.cType = TYPE_DATA;
  rh.cStatus = 2;
  rh.iLength = RHDR_SIZE + NRA_SIZE 
				+ iDescLength + iCateLength + iLocaLength
				+ iRepeLength;
  rh.iRecord = work_csvd->iRecordNum;

  /* Set all record offset */
  work_nra->iLength = NRA_SIZE 
				+ iDescLength + iCateLength + iLocaLength
				+ iRepeLength;
  work_nra->iOsCategory = NRA_SIZE 
				+ iDescLength;
  work_nra->iOsLocation = NRA_SIZE
				+ iDescLength + iCateLength;
  work_nra->iOsRepeat = NRA_SIZE
				+ iDescLength + iCateLength + iLocaLength;

  if (work_nra->iNoteRecNum != -1){
	iSum = 0;
	work_sinf=pSeekInfo[TYPE_NOTE];
    for(;work_sinf;work_sinf=work_sinf->pnext_sinf)
      iSum++;
    work_nra->iNoteRecNum = iSum;
	iNoteLength = strlen(work_csvd->pszNote) ;
  }

  AddSeekInfo(pSeekInfo, &rh, ftell(fpout));
  fwrite_RHDR(&rh, RHDR_SIZE, 1, fpout);
  fwrite_NRA(work_nra, NRA_SIZE, 1, fpout);
  fwrite(work_csvd->pszDescription, iDescLength, 1, fpout);
  fwrite(work_csvd->pszCategory,    iCateLength, 1, fpout);
  fwrite(work_csvd->pszLocation,    iLocaLength, 1, fpout);
/*
fprintf(stdout, "%d\n", work_nra->cRepeatType);
fprintf(stdout, "%d\n", work_ria->cFreq);
fprintf(stdout, "%d\n", work_ria->Days);
fprintf(stdout, "%d\n", work_ria->Weeks);
fprintf(stdout, "%d\n", work_ria->Month1);
fprintf(stdout, "%d\n", work_ria->Month2);
fprintf(stdout, "%d\n", work_ria->cStartYear);
fprintf(stdout, "%d\n", work_ria->cStartMonth);
fprintf(stdout, "%d\n", work_ria->cStartDay);
fprintf(stdout, "%d\n", work_ria->cEndYear);
fprintf(stdout, "%d\n", work_ria->cEndMonth);
fprintf(stdout, "%d\n", work_ria->cEndDay);
fprintf(stdout, "%d\n", work_ria->cDelete);
*/
  if (work_nra->cRepeatType > 1){
	fwrite_RIA(work_ria, RIA_SIZE, 1, fpout);
	if (work_ria->cDelete)
	  fwrite(work_csvd->pszDelRepeat, iDelRLength, 1, fpout);
  }

  if (work_nra->iNoteRecNum != -1){
	rh.cType = TYPE_NOTE;
	rh.cStatus = 2;
	rh.iLength = RHDR_SIZE + iNoteLength;
	rh.iRecord = iSum; 
	AddSeekInfo(pSeekInfo, &rh, ftell(fpout));
	fwrite_RHDR(&rh, RHDR_SIZE, 1, fpout);
	fwrite(work_csvd->pszNote, iNoteLength, 1, fpout);
  }

  if (iDebugG){
	fprintf(stdout, "%s\n", work_csvd->pszDescription);
	fprintf(stdout, "%s\n", work_csvd->pszLocation);
	fprintf(stdout, "%d, %d, %d\n",
	  		(work_csvd->pnra)->cYear,
	  		(work_csvd->pnra)->cMonth,
	  		(work_csvd->pnra)->cDay);
/*	fprintf(stdout, "%d\n", (work_csvd->pnra)->iStartTime);*/
/*	fprintf(stdout, "%d\n", (work_csvd->pnra)->iEndTime);*/
	fprintf(stdout, "%d\n", (work_csvd->pnra)->iEndDate);
	fprintf(stdout, "%s\n\n", work_csvd->pszNote);
  }
}
