#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "apptout.h"

extern FILE   *fpout;
extern short  iInCSV;
extern short  iDebugG;
extern short  iOutAppt;
extern short  iSilent;
extern short  iDataNum;
extern short  iNoteNum;
extern short  iCSV;
extern short  iOffsetLength;

void WriteDB(PFDC start_fdc, PSINF *pSeekInfo, char * szBuffer)
{
  RHDR	rh;
  PFDC  curr_fdc, next_fdc;
  PFDEF curr_fd, next_fd;
  short i, j, k;
  short iNoteLength;
  short iCurrOffset;
  short iLength;
  short iMinute;
  short iOffset;
  short iNoteOffset;
  short iGroupFlag;
  short iRadio;
  short iCheck;
  char cOffset[100];
  char *pszData;
  char *pszNote;
  unsigned char szTime[4];
  unsigned char *pszWriteData;
  unsigned char *pszWriteDataNew;

  iGroupFlag = 0;
  iCurrOffset = 0;
  iOffset = 0;
  iNoteOffset = -1;
  pszWriteData = NULL;
  iRadio = 1;

  memset(cOffset, '\0', 100);

  if (iSilent%2 != 1){
	fprintf(stdout, "%s", szBuffer);
  }

  i = 0;
  curr_fdc=start_fdc;
  for(; curr_fdc; curr_fdc=curr_fdc->pnext_fdc, i++){
	curr_fd = curr_fdc->pfd;

	switch(curr_fd->cFieldType){
	  case 9:		/* Push button */
		break;
	  case 11:		/* Group field */
	    i--;
		iGroupFlag = 1;
		continue;
		break;
	  case 12:		/* Static field */
	  case 14:		/* Multiline field */
	    i--;
	    iGroupFlag = 0;
		continue;
		break;
	  default:
		iGroupFlag = 0;
		break;
	}

	/* Get 1 record */
	if (iCSV == 1)
      pszData = GetCSV(szBuffer, i+1, '0');
    else
      pszData = GetCSV(szBuffer, i+1, '\"');

/*
fprintf(stdout, "(%d) pszData=%s, iOffset=%d, iCurrOffset=%d\n",
	i+1, pszData, iOffset, iCurrOffset);
*/

	switch(curr_fd->cFieldType){
	  case 0:		/* Check box(byte) */
	  case 1:		/* Check box(word) */
		iMinute = atoi(pszData);
		cOffset[iOffset] = iMinute % 0x100;
		cOffset[iOffset+1] = iMinute / 0x100;
		iOffset = iOffset + 2;
		free(pszData);
		continue;
		break;

	  case 9:		/* Push button */
		if (iGroupFlag){
		  if (atoi(pszData)){
			iRadio = curr_fd->cReserved1;
		  }
/*		  else{
			iRadio = 1;
		  }*/
		  next_fdc=curr_fdc->pnext_fdc;
		  if (next_fdc){
			next_fd=next_fdc->pfd;
			if (next_fd->cFieldType != 9){
			  cOffset[iOffset] = iRadio % 0x100;
			  cOffset[iOffset+1] = iRadio / 0x100;
			  iOffset = iOffset + 2;
			}
		  }else{
			cOffset[iOffset] = iRadio % 0x100;
			cOffset[iOffset+1] = iRadio / 0x100;
			iOffset = iOffset + 2;
		  }
		}
		free(pszData);
		continue;
		break;

	  case 7:	/* Time */
		if (strlen(pszData)){
		  if (!strstr(pszData, "NONE") || !strstr(pszData, "none")){
			iMinute = atoi(strtok(pszData, ":")) * 60;
			iMinute = atoi(strtok(NULL, ":")) + iMinute;
			szTime[0] = iMinute % 0x100;
			szTime[1] = iMinute / 0x100;
		  }else{
			szTime[0] = 0;
			szTime[1] = 0x80;
		  }
		}else{
		  szTime[0] = 0;
		  szTime[1] = 0x80;
		}
		szTime[2] = '\0';
		cOffset[iOffset] = szTime[0];
		cOffset[iOffset+1] = szTime[1];
		iOffset = iOffset + 2;
		free(pszData);
		continue;
		break;

	  case 8:	/* Date */
		if (strlen(pszData)){
		  szTime[0] = (unsigned char)(atoi(strtok(pszData, "/")) - 1900);
		  szTime[1] = (unsigned char)(atoi(strtok(NULL, "/")) - 1);
		  szTime[2] = (unsigned char)(atoi(strtok(NULL, "/")) - 1);
		}else{
		  szTime[0] = 255;
		  szTime[1] = 255;
		  szTime[2] = 255;
		}
		szTime[3] = '\0';
		cOffset[iOffset] = szTime[0];
		cOffset[iOffset+1] = szTime[1];
		cOffset[iOffset+2] = szTime[2];
		iOffset = iOffset + 3;
		free(pszData);
		continue;
		break;

	  case 10:	/* Note */
		if (strlen(pszData)){
		  cOffset[iOffset] = iNoteNum % 0x100;
		  cOffset[iOffset+1] = iNoteNum / 0x100;
		}else{
		  cOffset[iOffset] = -1;
		  cOffset[iOffset+1] = -1;
		}
		iNoteOffset = iOffset;
		iOffset = iOffset + 2;
		pszNote = pszData;
		continue;
		break;

	  default:
		/* 1 record length */
		iLength = strlen(pszData);

		break;
	}

    if (iDebugG){
	  fprintf(stdout, "pszData(%d)=%s\n", i, pszData);
    }
/*
fprintf(stdout, "iLength=%d\n", iLength);
*/
	/* Set index to data */
	if (iLength){
	  cOffset[iOffset] = (iOffsetLength + 1 + iCurrOffset) % 0x100;
	  cOffset[iOffset+1] = (iOffsetLength + 1 + iCurrOffset) / 0x100;
	  iOffset = iOffset + 2;
	}else{
	  /* Data nothing is 30th bytes */
	  cOffset[iOffset] = iOffsetLength % 0x100;
	  cOffset[iOffset+1] = iOffsetLength / 0x100 ;
	  iOffset = iOffset + 2;
	  free(pszData);
	  continue;
	}

	/* Cuurent record length */
	iLength = iLength + 1 + iCurrOffset;

	if ((pszWriteDataNew=(unsigned char *)malloc(iLength)) == NULL){
	  fprintf(stderr, "2. Not enough memory in WriteDB.\n");
	  exit(1);
	}
	memset(pszWriteDataNew, '\0', iLength);

	/* Make data strings */
	if (pszWriteData){
	  for (j=0;j<iCurrOffset;j++)
	  	pszWriteDataNew[j] = pszWriteData[j];	/* Copy New <- Old */
	  for (j=iCurrOffset,k=0;j<iLength;j++,k++){
	  	pszWriteDataNew[j] = pszData[k];		/* Add New <- Data */
	  }
	  free(pszWriteData);
	}else{
	  for (j=0;j<iLength;j++)
	  	pszWriteDataNew[j] = pszData[j];
	}
	free(pszData);

	pszWriteData = pszWriteDataNew;
    iCurrOffset = iLength;
  }

  if (iOutAppt){
	rh.cType = TYPE_DATA;
	rh.cStatus = 0x01;
	rh.iLength = RHDR_SIZE + iOffsetLength + 1 + iCurrOffset;
	rh.iRecord = iDataNum;
	AddSeekInfo(pSeekInfo, &rh, ftell(fpout));
	fwrite_RHDR(&rh, RHDR_SIZE, 1, fpout);
	fwrite(cOffset, iOffsetLength, 1, fpout);
	fwrite("\0", 1, 1, fpout);
	fwrite(pszWriteData, iCurrOffset, 1, fpout);
	iDataNum++;

	if (*(short int *)&cOffset[iNoteOffset] != -1){
	  iNoteLength = strlen(pszNote);
	  pszNote = ChangeString(pszNote);

	  rh.cType = TYPE_NOTE;
	  rh.cStatus = 0x01;
	  rh.iLength = RHDR_SIZE + iNoteLength;
	  rh.iRecord = iNoteNum; 
	  cOffset[iNoteOffset] = iNoteNum % 0x100;
	  cOffset[iNoteOffset+1] = iNoteNum / 0x100;

	  AddSeekInfo(pSeekInfo, &rh, ftell(fpout));
	  fwrite_RHDR(&rh, RHDR_SIZE, 1, fpout);
	  fwrite(pszNote, iNoteLength, 1, fpout);
	  iNoteNum++;
	}
  }
  free(pszWriteData);
}
