#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "apptout.h"

extern FILE *fpout;
extern long lLast;
extern short iDebugG;
extern PRHDR  pview_rh;

int WriteLookUpSeek(PSINF *pSeekInfo)
{
  unsigned char cIndex[8];
  unsigned char cBuf[8];
  short iMaxRecordNum;
  short i;
  short iSum;
  RHDR  rh;
  PSINF work_sinf;

  /* Write view-point-table */
  rh.cType = 10;
  rh.cStatus = 2;
  rh.iLength = 6;
  rh.iRecord = 0;
  AddSeekInfo(pSeekInfo, &rh, ftell(fpout));
  fwrite_RHDR(&rh, RHDR_SIZE, 1, fpout);

  lLast = ftell(fpout);

  /* Get max record number */
  iMaxRecordNum = 0;
  for(i=0;i<32;i++){
    for(work_sinf=pSeekInfo[i];work_sinf;work_sinf=work_sinf->pnext_sinf)
      iMaxRecordNum++;
  }

  /* Set record header */
  rh.cType = TYPE_LOOKUPTABLE;
  rh.cStatus = 2;
  rh.iLength = iMaxRecordNum * 8 + 6;
  rh.iRecord = 0;

  /* Write record header */
  fwrite_RHDR(&rh, RHDR_SIZE, 1, fpout);

  /* Set and make Index table */
  for(i=0;i<32;i++){
    for(work_sinf=pSeekInfo[i];work_sinf;work_sinf=work_sinf->pnext_sinf){
	  cIndex[0] = work_sinf->iSize % 0x100;
	  cIndex[1] = work_sinf->iSize / 0x100;
	  cIndex[2] = -1;
	  cIndex[3] = -1;
	  if (work_sinf->lSeekPt)
		cIndex[4] = 0;
	  else		/* Record was deleted */
		cIndex[4] = 0xc0;
	  cIndex[5] = work_sinf->lSeekPt % 0x100;
	  cIndex[6] = work_sinf->lSeekPt / 0x100 % 0x100;
	  cIndex[7] = work_sinf->lSeekPt / 0x10000;
      fwrite(cIndex, 8, 1, fpout);
    }
  }

  iSum = 0;
  for(i=0;i<32;i++){
    if(iDebugG){
      fprintf(stdout, "iSum = %d\n", iSum);
    }
    cBuf[0] = iSum % 0x100;
    cBuf[1] = iSum / 0x100;
    fwrite(cBuf, 2, 1, fpout);
    for(work_sinf=pSeekInfo[i];work_sinf;work_sinf=work_sinf->pnext_sinf){
      iSum++;
    }
  }
  return(iMaxRecordNum);
}
